/* Cholesky ʬ */
void cholesky(int n, matrix L, matrix a)
{
  int i, j, k;
  double s;
  for (j = 1; j <= n; j++) {
    /* L[j][j] η׻ */
    s = a[j][j];
    for (k = 1; k < j; k++)
      s -= sqr(L[j][k]);
    if (s < 0) {
      fprintf(stderr, "s < 0\n");
      exit(0);
    }
    L[j][j] = sqrt(s);
    for (i = j + 1; i <= n; i++) {
      s = a[i][j];
      for (k = 1; k < j; k++)
        s -= L[i][k] * L[j][k];
      L[i][j] = s / L[j][j];
    }
  }
}
