/* Cholesky ʬ A=U^T U (A гξȾʬΤ߻) */
void cholesky(int n, matrix U, matrix a)
{
  int j, i, k;
  double s;
  for (i = 1; i <= n; i++) {
    /* U[i][i] η׻ */
    s = a[i][i];
    for (k = 1; k < i; k++)
      s -= sqr(U[k][i]);
    if (s < 0) {
      fprintf(stderr, "s < 0\n");
      exit(0);
    }
    U[i][i] = sqrt(s);
    for (j = i + 1; j <= n; j++) {
      s = a[i][j];
      for (k = 1; k < i; k++)
        s -= U[k][j] * U[k][i];
      U[i][j] = s / U[i][i];
    }
  }
}
