/*
 * cholesky3.c
 */

#include <stdio.h>
#include <math.h>
#include <matrix.h>
#include <limits.h>

/* [0,1) ϰϤΰ͵ */
double drandom()
{
  return random() / (double) INT_MAX;
}

/* ߥ٥ȥ */
void mul_mv(int n, vector Ab, matrix A, vector b)
{
  int i;
  for (i = 1; i <= n; i++)
    Ab[i] = dotprod(n, A[i]+1, b+1);
}

/*  */
void mul_mm(int n, matrix ab, matrix a, matrix b)
{
  int i, j, k;
  double s;
  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++) {
      s = 0;
      for (k = 1; k <= n; k++)
        s += a[i][k] * b[k][j];
      ab[i][j] = s;
    }
}

/* ٥ȥɽ */
void print_vector(int n, vector x)
{
  int i;
  for (i = 1; i <= n; i++)
    printf("%f ", x[i]);
  printf("\n");
}

/* ɽ */
void print_matrix(int n, matrix a)
{
  int i, j;
  for (i = 1; i <= n; i++) {
    for (j = 1; j <= n; j++)
      printf("%f ", a[i][j]);
    printf("\n");
  }
}

/* ˤ */
void clear_m(int n, matrix a)
{
  int i, j;
  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
      a[i][j] = 0;
}

/*  */
double sqr(double x) { return x * x; }

/* Cholesky ʬ */
#include "cholesky-jik.c"

/* ѹ򷸿ȤϢΩ켡 */
#include "solve-triangle.c"

int main()
{
  int i, j, N;
  matrix a, L, Lt;
  vector x, b;
  printf("N="); scanf("%d", &N);
  a = new_matrix(N+1, N+1);
  L = new_matrix(N+1, N+1);
  Lt = new_matrix(N+1, N+1);
  x = new_vector(N+1);
  b = new_vector(N+1);
  for (i = 1; i <= N; i++) {
    for (j = 1; j <= i; j++)
      Lt[j][i] = L[i][j] = drandom();
    for (j = i + 1; j <= N; j++)
      Lt[j][i] = L[i][j] = 0.0;
  }
  mul_mm(N, a, L, Lt);
  printf("L=\n");
  print_matrix(N, L);
  printf("a=\n");
  print_matrix(N, a);

  clear_m(N, L);
  cholesky(N, L, a);
  printf("L=\n");
  print_matrix(N, L);

  /* ϢΩ1 */
  for (i = 1; i <= N; i++)
    x[i] = i;
  mul_mv(N, b, a, x);

  solve_lxb(N, L, b);
  solve_ltxb(N, L, b);
  printf("x=\n");
  print_vector(N, b);

  return 0;
}
