/*
 * testpack.c
 */

#include <stdio.h>
#include <matrix.h>
#include <limits.h>

/* [0,1) ΰ͵ */
double drandom()
{
  return random() / (double) INT_MAX;
}

/* Ǿ,  */
int min(int a, int b) { return (a < b) ? a : b; }
int max(int a, int b) { return (a > b) ? a : b; }

/* Υꥢ */
void clear_matrix0(int m, int n, matrix a)
{
  int i, j;
  for (i = 0; i < m; i++)
    for (j = 0; j < n; j++)
      a[i][j] = 0;
}

/* Υꥢ */
void clear_matrix1(int m, int n, matrix a)
{
  int i, j;
  for (i = 1; i <= m; i++)
    for (j = 1; j <= n; j++)
      a[i][j] = 0;
}

/* ӹ */
void random_band0(int n, int m, matrix a)
{
  int i, j;
  clear_matrix0(n, n, a);
  for (i = 0; i < n; i++)
    for (j = max(0, i-m); j <= min(i+m, n-1); j++)
      a[i][j] = drandom();
}

/* ӹ */
void random_band1(int n, int m, matrix a)
{
  int i, j;
  clear_matrix1(n, n, a);
  for (i = 1; i <= n; i++)
    for (j = max(1, i-m); j <= min(i+m, n); j++)
      a[i][j] = drandom();
}

/* оӹ */
void random_symmetric_band0(int n, int m, matrix a)
{
  int i, j;
  clear_matrix0(n, n, a);
  for (i = 0; i < n; i++)
    for (j = i; j <= min(i+m, n-1); j++)
      a[i][j] = a[j][i] = drandom();
}

/* оӹ */
void random_symmetric_band1(int n, int m, matrix a)
{
  int i, j;
  clear_matrix1(n, n, a);
  for (i = 1; i <= n; i++)
    for (j = i; j <= min(i+m, n); j++)
      a[i][j] = a[j][i] = drandom();
}

/* ɽ */
print_matrix0(int m, int n, matrix a)
{
  int i, j;
  for (i = 0; i < m; i++) {
    for (j = 0; j < n; j++)
      printf("%f ", a[i][j]);
    printf("\n");
  }
}

/* ɽ */
print_matrix1(int m, int n, matrix a)
{
  int i, j;
  for (i = 1; i <= m; i++) {
    for (j = 1; j <= n; j++)
      printf("%f ", a[i][j]);
    printf("\n");
  }
}

/*
 * ӹͤ
 *
 * ȾХ m 
 *   A=(a_{ij}) (0in-1, 0jn-1)
 * 
 *   AB=(ab_{ij) (0in-1, 0j2m)
 * ˵ͤ
 *
 *   ab[i][j-i+m] = a[i][j]  (0in-1, max(i-m,0)jmin(i+m,n-1))
 *                                       |i-j|m Ȥ
 *
 *   a[i][i+j-m] = ab[i][j]  (0in-1, ??max(m-i,0)jmin(m-i+N-1,N-1))
 */
void pack0(int n, int m, matrix ab, matrix a)
{
  int i, j;
  clear_matrix0(n, 2*m+1, ab);
  for (i = 0; i < n; i++)
    for (j = max(i-m,0); j <= min(i+m,n-1); j++)
      ab[i][j-i+m] = a[i][j];
}

/*
 * ӹͤ
 *
 * ȾХ m 
 *   A=(a_{ij}) (1in, 1jn)
 * 
 *   AB=(ab_{ij) (1in, 1j2m+1)
 * ˵ͤ
 *
 *   ab[i][j-i+m+1] = a[i][j]  (1in, max(i-m,1)jmin(i+m,n))
 *                                       |i-j|m Ȥ
 *
 * a[i][i+j-m] = ab[i][j]  (0in-1, ??max(m-i,0)jmin(m-i+N-1,N-1))
 */
void pack1(int n, int m, matrix ab, matrix a)
{
  int i, j;
  clear_matrix1(n, 2*m+1, ab);
  for (i = 1; i <= n; i++)
    for (j = max(i-m,1); j <= min(i+m,n); j++)
      ab[i][j-i+m+1] = a[i][j];
}

/*
 * оӹͤ
 *
 * ȾХ m оι
 *   A=(a_{ij}) (0in-1, 0jn-1)
 * 
 *   ASB=(asb_{ij) (0in-1, 0jm)
 * ˵ͤ
 *
 *   asb[i][j-i] = a[i][j]  (0in-1, ijmin(i+m,n-1))
 *
 */
void pack_symmetric0(int n, int m, matrix asb, matrix a)
{
  int i, j;
  clear_matrix0(n, m+1, asb);
  for (i = 0; i < n; i++)
    for (j = i; j <= min(i+m,n-1); j++)
      asb[i][j-i] = a[i][j];
}

/*
 * оӹͤ
 *
 * ȾХ m оι
 *   A=(a_{ij}) (1in, 1jn)
 * 
 *   ASB=(asb_{ij) (1in, 1jm+1)
 * ˵ͤ
 *
 *   asb[i][j-i+1] = a[i][j]  (1in, ijmin(i+m,n))
 *
 */
void pack_symmetric1(int n, int m, matrix asb, matrix a)
{
  int i, j;
  clear_matrix1(n, m+1, asb);
  for (i = 1; i <= n; i++)
    for (j = i; j <= min(i+m,n); j++)
      asb[i][j-i+1] = a[i][j];
}

/* ѥåƤӹɽ */
void print_band_matrix0(int n, int m, matrix ab)
{
  int i, j;
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++)
       if (j < i - m || j > i + m)
         printf("%f ", 0.0);
       else
         printf("%f ", ab[i][j-i+m]);
    printf("\n");
  }
}

/* ѥåƤӹɽ */
void print_band_matrix1(int n, int m, matrix ab)
{
  int i, j;
  for (i = 1; i <= n; i++) {
    for (j = 1; j <= n; j++)
       if (j < i - m || j > i + m)
         printf("%f ", 0.0);
       else
         printf("%f ", ab[i][j-i+m+1]);
    printf("\n");
  }
}

/* ѥåƤӹɽ */
void print_symmetric_band_matrix0(int n, int m, matrix asb)
{
  int i, j;
  for (i = 0; i < n; i++) {
    for (j = 0; j < n; j++)
       if (abs(j - i) > m)
         printf("%f ", 0.0);
       else {
         if (j >= i)
           printf("%f ", asb[i][j-i]);
         else /* פ i  j ؤ */
           printf("%f ", asb[j][i-j]);
       }
    printf("\n");
  }
}

/* ѥåƤӹɽ */
void print_symmetric_band_matrix1(int n, int m, matrix asb)
{
  int i, j;
  for (i = 1; i <= n; i++) {
    for (j = 1; j <= n; j++)
       if (abs(j - i) > m)
         printf("%f ", 0.0);
       else {
         if (j >= i)
           printf("%f ", asb[i][j-i+1]);
         else /* פ i  j ؤ */
           printf("%f ", asb[j][i-j+1]);
       }
    printf("\n");
  }
}

int main()
{
  int n,m;
  matrix a, ab, asb;
  n = 7; m = 2;
  printf("ȾХ %d  %d \n", m, n);
  a = new_matrix(n+1, n+1); clear_matrix0(n+1,n+1,a);
  ab = new_matrix(n+1, (2*m+1)+1); clear_matrix0(n+1,2*m+1+1,ab);
  asb = new_matrix(n+1, (m+1)+1); clear_matrix0(n+1,(m+1)+1,asb);

  srandom(0);
  random_band0(n, m, a); 
  printf("a=\n"); print_matrix0(n, n, a);
  pack0(n, m, ab, a);
  printf("ab=(ѥå)\n"); print_matrix0(n, 2*m+1, ab);
  printf("ab=(̤η)\n"); print_band_matrix0(n, m, ab);

  srandom(0);
  random_band1(n, m, a); 
  printf("a=\n"); print_matrix1(n, n, a);
  pack1(n, m, ab, a);
  printf("ab=(ѥå)\n"); print_matrix1(n, 2*m+1, ab);
  printf("ab=(̤η)\n"); print_band_matrix1(n, m, ab);

  srandom(0);
  random_symmetric_band0(n, m, a); 
  printf("оΤ A=\n"); print_matrix0(n, n, a);
  pack_symmetric0(n, m, asb, a);
  printf("ab= (ѥå)\n"); print_matrix0(n, m+1, asb);
  printf("ab= (̤η)\n"); print_symmetric_band_matrix0(n, m, asb);

  srandom(0);
  random_symmetric_band1(n, m, a); 
  printf("оΤ A=\n"); print_matrix1(n, n, a);
  pack_symmetric1(n, m, asb, a);
  printf("ab= (ѥå)\n"); print_matrix1(n, m+1, asb);
  printf("ab= (̤η)\n"); print_symmetric_band_matrix1(n, m, asb);

  return 0;
}
